<?php

/**
 * co_campo_ep_prueba actions.
 *
 * @package    contratacion
 * @subpackage co_campo_ep_prueba
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
require_once 'HTMLPurifier.auto.php';
require 'HTMLPurifier.autoload.php';

class co_campo_modalidadActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeList(sfWebRequest $request)
  {
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            $consulta=$request['id_modalidad_sel'];
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from 
                    (
                   SELECT 
tab0.id_campo_modalidad,
tab0.campo_ep.id_campo_ep as id_campo_ep,
tab0.id_modalidad_sel,
tab0.orden,
tab0.estado,
tab1.prefijo as prefijo_modalidad,
tab1.descripcion as descripcion_modalidad,
tab0.campo_ep.descripcion as descripcion_campoep,
tab0.campo_ep.campo_fijo as campo_fijo
FROM CO_CAMPO_MODALIDAD tab0
LEFT JOIN CO_MODALIDAD_SEL tab1 on tab1.id_modalidad_sel = tab0.id_modalidad_sel
WHERE
1=1 
and tab0.id_modalidad_sel=$consulta
order by tab0.orden     
   
   )
                    
EOD;
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];
            //validar si hay registros
            if ($total_record_count > 0) {
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
SELECT 
tab0.id_campo_modalidad,
tab0.campo_ep.id_campo_ep as id_campo_ep,
tab0.id_modalidad_sel,
tab0.orden,
tab0.estado,
tab1.prefijo as prefijo_modalidad,
tab1.descripcion as descripcion_modalidad,
tab0.campo_ep.descripcion as descripcion_campoep,
tab0.campo_ep.campo_fijo as campo_fijo,
tab0.default_value
FROM CO_CAMPO_MODALIDAD tab0
LEFT JOIN CO_MODALIDAD_SEL tab1 on tab1.id_modalidad_sel = tab0.id_modalidad_sel
WHERE
1=1 
and tab0.id_modalidad_sel=$consulta
order by tab0.orden
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);
                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('CO_CAMPO_EP');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowStart + count($records);
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[INF_CO_CAMPO_MODALIDAD] Consulta exitosa.");
            }
            else {

                $mensaje = "[INF_CO_CAMPO_MODALIDAD] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error = "[INF_CO_CAMPO_MODALIDAD] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeAdd(sfWebRequest $request)
  {
      $config = HTMLPurifier_Config::createDefault();
        $purifier = new HTMLPurifier($config);
    $this->logMessage("[INF_CO_CAMPO_MODALIDAD] Entra por agregar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id_modalidad_sel=$request['id_modalidad_sel'];
            $id_campo_ep=$request['id_campo_ep'];
            $orden=$request['orden'];
            $estado=$request['estado'];
            $valor = $request['default_value'];
            $valor_limpio = $purifier->purify($valor);
            $request['default_value'] = $valor_limpio;
            $default_value=$request['default_value'];
            if($estado=="true"){
                $estado=1;
            }
            else{
                $estado=0;
            }
            $sql = <<<EOD
INSERT INTO CO_CAMPO_MODALIDAD (ID_CAMPO_MODALIDAD,ID_MODALIDAD_SEL,CAMPO_EP,ORDEN,ESTADO,DEFAULT_VALUE) VALUES ('','$id_modalidad_sel',(SELECT REF(e) FROM CO_CAMPO_EP e WHERE e.ID_CAMPO_EP=$id_campo_ep),'$orden',$estado,'$default_value')
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_CAMPO_EP] Consulta exitosa");
        } catch (Exception $ex) {
            $error = "[INF_CO_CAMPO_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeUpdate(sfWebRequest $request)
  {
      $config = HTMLPurifier_Config::createDefault();
      $purifier = new HTMLPurifier($config);
    $this->logMessage("[INF_CO_CAMPO_EP] Entra por editar objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id=$request['id_campo_modalidad'];
            $id_modalidad_sel=$request['id_modalidad_sel'];
            $id_campo_ep=$request['id_campo_ep'];
            $orden=$request['orden'];
            $estado=$request['estado'];
            $valor = $request['default_value'];
            $valor_limpio = $purifier->purify($valor);
            $request['default_value'] = $valor_limpio;
            $default_value=$request['default_value'];
            if($estado=="true"){
                $estado=1;
            }
            else{
                $estado=0;
            }
            $sql = <<<EOD
UPDATE CO_CAMPO_MODALIDAD SET ID_MODALIDAD_SEL='$id_modalidad_sel',CAMPO_EP=(SELECT REF(e) FROM CO_CAMPO_EP e WHERE e.ID_CAMPO_EP=$id_campo_ep),ORDEN='$orden',ESTADO=$estado,DEFAULT_VALUE='$default_value' WHERE ID_CAMPO_MODALIDAD=$id
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[INF_CO_CAMPO_EP] Consulta exitosa");
        } catch (Exception $ex) {
            $error = "[INF_CO_CAMPO_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
  public function executeRemove(sfWebRequest $request)
  {
      $config = HTMLPurifier_Config::createDefault();
      $purifier = new HTMLPurifier($config);
    $this->logMessage("[CO_CAMPO_MODALIDAD] Entra por remover objeto.");
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id=$request['id_campo_modalidad'];

            $sql = <<<EOD
DELETE FROM CO_CAMPO_MODALIDAD WHERE ID_CAMPO_MODALIDAD=$id
EOD;
            //ejecuta y obtiene el resultado del sql
             $records = CN_TABLE::executeSQL($sql);
             $this->status = 0;
             $this->list_data = $records;
             $this->logMessage("[CO_CAMPO_MODALIDAD] Consulta exitosa");
        } catch (Exception $ex) {
            $error = "[CO_CAMPO_MODALIDAD] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
  }
}